# NVDA Volume Adjustment (Регулировка громкости)

* Автор: Олександр Грищенко
* Версия: 1.3
* Совместимость с NVDA: 2019.3 и более новые версии
* Загрузить [стабільную версию][1]

Слава Украине! Героям слава!!!

Отрегулируйте уровень громкости всех аудиоустройств, установленных в системе, и каждой запущенной программы отдельно с помощью простых комбинаций клавиш.

Вы всегда можете изменить комбинации клавиш по умолчанию на удобные для вас через диалоговое окно настроек жестов введения NVDA.

## Особенности дополнения
* настройка уровня громкости всех аудио-устройств в системе;
* регулировка громкости для каждой запущенной программы отдельно;
* возможность регулировать громкость каждого канала выбранного аудиоустройства или устанавливать среднее значение громкости для всех каналов;
* быстрое переключение на максимальный или минимальный уровень громкости любого источника звука или выбранного канала;
* два режима приглушения источника звука - полное отключение или уменьшение громкости на величину в процентах;
* возможность восстановления уровня громкости всех доступных приглушенных источников звука при завершении работы NVDA;
* гибкая настройка отображения перечня выявленных аудио устройств и запущенных программ;
* автоматическое переключение на программу, находящуюся в фокусе;
* возможность установить собственный шаг изменения громкости;
* быстрое переключение вывода на другие доступные аудиоустройства.

## Переключение между источниками звука
Перейти к предыдущему или следующему источнику звука можно с помощью комбинаций клавиш NVDA+Windows+ стрелки влево или вправо. Список состоит из двух частей - системных аудиоустройств и запущенных аудиосесий. Переключение происходит циклически по кругу подобно кругу настроек NVDA.

Через панель настроек приложения можно скрыть любые элементы этого списка.

Переключение между аудиосесиямы может происходить автоматически при переключении на окно соответствующей программы - этот режим включается в настройках дополнения.

Примечание: Список аудиосесий меняется динамически и зависит от запущенных программ.

## Регулировка уровня громкости
Выбрав источник звука можно изменить его громкость с помощью следующих команд:

* увеличить громкость - NVDA+Windows+ стрелка вверх;
* уменьшить громкость - NVDA+Windows+ стрелка вниз;
* установить максимальный уровень громкости - NVDA+Windows+Home (Будьте осторожны, это действие может привести к повреждению слуха);
* установить минимальный уровень громкости - NVDA+Windows+End;
* отключить выбранный источник звука - NVDA+Windows+ стрелка вниз (когда установлен минимальный уровень громкости);
* приглушить громкость или восстановить уровень громкости ранее приглушенного источника звука - NVDA+Windows+Escape, режим приглушения можно выбрать в панели настроек дополнения.

Примечание: По умолчанию за одно нажатие громкость меняется на один процент. Это значение можно изменить в панели настроек дополнения в диапазоне от 1 до 20.

## Настройка громкости выбранного канала
Для выбранного источника звука доступны также настройки уровня громкости отдельных его каналов:

* переключение между всеми каналами выбранного источника звука - NVDA+Shift+Windows+ стрелки влево или вправо;
* увеличение или уменьшение громкости выбранного канала - NVDA+Shift+Windows+ стрелки вверх или вниз;
* установка максимального или минимального уровня громкости выбранного канала - NVDA+Shift+Windows+ Home или End;
* установка среднего арифметического значения уровня громкости для всех каналов - NVDA+Shift+Windows+Escape.

Примечание: Функция регулировки громкости каналов пока доступна только для аудио-устройств.

## Быстрое переключение между аудио устройствами вывода звука
Для переключения вывода всех звуков NVDA на следующее доступное аудио устройство достаточно нажать комбинацию клавиш NVDA+Windows+PageUp.

Чтобы вернуться к предыдущему аудио устройству воспользуйтесь командой NVDA+Windows+PageDown.

Кроме того, чтобы быстро переключить вывод звука NVDA на выбранное аудио-устройство, можно воспользоваться клавишами NVDA+Windows+ функциональные клавиши начиная от F1.

Примечание: Для всех обнаруженных в системе выходных аудио-устройств создаются отдельные функции переключения на них. Все эти функции отображаются в диалоговом окне "Жесты ввода", где есть возможность назначить команды активации для каждого из выявленных устройств.

## Окно настроек дополнения
Следующие опции позволят гибко настроить поведение приложения и список аудиоресурсов для переключения между ними.

### Объявления состояния источника звука при переключении
Если установлен этот флажок, то при переключении между источниками звука или между каналами будет объявляться их текущее состояние, а именно - значение уровня громкости или признак приглушивания.

### Шаг изменения уровня громкости
Минимальная величина, на которую изменится уровень громкости при одном нажатии клавиш. Можно установить значение от 1 до 20 пунктов.

### Автоматическое переключение аудиосесии
Если установлен этот флажок - приложение будет автоматически переключаться на аудиосесию, что соответствует программе в фокусе.

Например, если вы в данный момент просматриваете сайт в Firefox, приложение определит это и автоматически переключится на аудиосесию Firefox. И вы можете сразу регулировать уровень громкости для текущего процесса не отыскивая его в списке.

### Скрыть аудио-сеансы с одинаковыми названиями
Иногда при запуске некоторых программ открывается несколько аудио-сессий с одинаковыми именами. Эта опция позволяет скрыть такие аудио-сессии.

### Сокрытие процессов
В этом списке флажков можно обозначить процессы, которые нужно скрыть из основного списка. Это могут быть, например, служебные программы.

Кнопка "Обновить" предназначена для обновления списка всех запущенных процессов и доступных аудиосесий. При этом отмеченные элементы остаются отмеченными.

Кнопка "Очистить" - снимает все флажки и удаляет неактуальные элементы.

### Управление всеми обнаруженными аудио-устройствами
Включает расширенные функции дополнения, а именно возможность регулировать громкость всех выявленных в системе аудиоустройств.

По неизвестным причинам эта функция вызывает ошибки на некоторых системах, поэтому она обозначена как экспериментальная.

### Сокрытие аудиоустройств
Если одно или несколько аудио-устройств вы не используете и не хотите, чтобы они присутствовали при переключении между аудио-источниками, вы можете легко удалить их из основного списка просто отметив их в панели настроек.

Кнопка "Обновить" предназначена для пересканирование всех имеющихся в системе устройств и отображения обновленной информации. При этом отмеченные элементы остаются отмеченными.

Кнопка "Очистить" - снимает все флажки и удаляет неактуальные элементы.

### Приглушение громкости
Функция приглушения громкости может работать в двух режимах:

1. Полностью отключить источник звука. Для включения этого режима необходимо выбрать соответствующий вариант в списке выбора режимов приглушивания.
2. Уменьшать громкость на указанное в процентах значение, которое можно отрегулировать с помощью слайдера в панели настроек дополнения.

Примечание: Есть возможность восстановить уровень громкости для всех приглушенных источников звука при завершении работы NVDA. Поскольку список аудиосесий меняется динамически - громкость будет восстановлена только для доступных на данный момент программ, которые воспроизводят звук.

### Использование комбинаций клавиш по умолчанию
Если вы не планируете использовать все функции дополнения. В панели настроек есть возможность выключить связанные по умолчанию комбинации клавиш для всех имеющихся функций. После чего вы можете назначить собственные комбинации клавиш через стандартное диалоговое окно NVDA "Жесты ввода ..." только для тех функций, которые вас интересуют.

## Благодарности
Мы очень благодарны всем, кто приложил усилия, чтобы разработать, перевести и поддерживать это дополнение:

* Dang Manh Cuong - перевод на Вьетнамский язык;
* Cagri Dogan - перевод на турецкий язык и тестирование предрелизов;
* Christianlm - перевод на итальянский язык;
* Cary Rowen - перевод на упрощенный китайский язык, много удачных идей и тестирование предрелизов;
* Stefan Banita - перевод на польский язык;
* Wafiqtaher - перевод на арабский язык.

## Известные проблемы
В некоторых системах функция сканирования всех имеющихся аудиоустройств по непонятным причинам вызывает сбои. Это известная проблема стороннего модуля PyCaw, которая пока не решена.

## Журнал изменений

### Версия 1.3.3
* дополнение протестировано на совместимость с NVDA 2022.1;
* добавлено набор функций для управления уровнем громкости отдельно каждого канала аудио-устройств;
* добавлена возможность информирования о состоянии источника звука или канала при переключении между ними;
* в диалоговом окне "Жесты ввода" отображается отдельная функция переключения для каждого обнаруженного в системе выходного аудио устройства;
* добавлена функция для полного или частичного временного приглушения выбранного источника звука;
* добавлена возможность включения всех доступных приглушенных источников звука при завершении работы NVDA;
* параметры выбора режимов приглушения звука были добавлены в панель настроек дополнения;
* добавлено предупреждение о возможном повреждении слуха при использовании функции установления максимальной громкости звука;
* существенно оптимизирован исходный код и добавлены MyPy подсказки типов;
* дополнение адаптировано для поддержки Python версий 3.7 и 3.8;
* обновлен сторонний модуль ** psutil **;
* обновлен перевод на китайский и украинский языки.

### Версия 1.2
* добавлены отдельные сочетания клавиш для быстрого переключения на выбранное аудио устройство вывода звука;
* добавлена возможность отключения всех привязаных по умолчанию сочетаний клавиш, которые используются в дополнении.

### Версия 1.1
* исправлена ошибка дублирования аудио-сессий связанных с одним запущенным процессом;
* исправлен метод выявления текущей аудио-сессии;
* усовершенствован метод определения названия текущего процесса;
* переопределение основного устройства вывода другим способом, если первая попытка была неудачной;
* усовершенствован код панели настроек дополнения;
* добавлена возможность быстрого переключения вывода звуков NVDA на другое доступное аудио-устройство.

### Версия 1.0: особенности реализации
* это дополнение базируется на расширенных функциях дополнения NVDA Unmute, которые были изъяты из исходного дополнения из-за несоответствия ее главной задаче;
* добавлена ​​возможность регулировки уровня громкости всех аудиоустройств, выявленных в системе;
* добавлены комбинации клавиш для быстрой установки максимального и минимального уровней громкости для выбранного источника звука;
* добавлена ​​панель настроек дополнения.

## Внесение изменений в код дополнения
Вы можете клонировать этот репозиторий, чтобы внести изменения в NVDA Volume Adjustment.

### Дополнительные зависимости
Следующие модули можно установить с помощью pip:

- markdown
- scons
- python-gettext

### Построение дополнения из репозитория
1. Откройте командную строку, перейдите в корневой каталог этого репозитория.
2. Запустите на выполнение команду ** scons **. Если не возникло ошибок, сгенерированное дополнение будет помещено в текущий каталог.

[1]: https://github.com/grisov/NVDA_Volume_Adjustment/releases/download/latest/volumeAdjustment-1.3.2.nvda-addon
